NDSummary.OnToolTipsLoaded("File:LZW.java",{37:"<div class=\"NDToolTip TClass LJava\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype37\"><div class=\"CPEntry TClass Current\"><div class=\"CPModifiers\"><span class=\"SHKeyword\">public</span></div><div class=\"CPName\">LZW</div></div></div><div class=\"TTSummary\">Classe che contiene le funzioni di codifica e decodifica dell\'algoritmo Lempel-Ziv-Welch.</div></div>",39:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype39\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">private static void</span> scrivi(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">byte</span>&nbsp;</td><td class=\"PName last\">b</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Funzione che prende in input un byte e lo scrive nel file di destinazione.</div></div>",40:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype40\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">private static void</span> adattaEScrivi(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">long</span>&nbsp;</td><td class=\"PName last\">a,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">long</span>&nbsp;</td><td class=\"PName last\">length</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Questa funzione prende in input un primo long <b>a</b> e un secondo long <b>length</b> e scrive una sequenza di bit, di lunghezza <b>length</b> e conservata in <b>a</b>, nel file di destinazione a gruppi di 8 bit alla volta. Se l\'ultimo gruppo ha meno di 8 bit viene salvato e caricato nel file alla succesiva chiamata di questa funzione.</div></div>",41:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype41\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">private static byte</span> iBitInverse(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">long</span>&nbsp;</td><td class=\"PName last\">x,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">int</span>&nbsp;</td><td class=\"PName last\">i,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">long</span>&nbsp;</td><td class=\"PName last\">length</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Questa funzione prende in input un long <b>x</b>, un int <b>i</b> e un long <b>length</b> e restituisce l\' <b>i</b> -esimo bit (contando da sinistra verso destra) della sequenza di bit di lunghezza <b>length</b> e conservata in <b>x</b>.</div></div>",42:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype42\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">private static void</span> preparazione() <span class=\"SHKeyword\">throws</span> IOException</div><div class=\"TTSummary\">Prepara il programma all\'esecuzione della codifica o della decodifica del file.</div></div>",43:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype43\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">public static void</span> code(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">String&nbsp;</td><td class=\"PName last\">source,</td></tr><tr><td class=\"PType first\">String&nbsp;</td><td class=\"PName last\">destName</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">throws</span> IOException</td></tr></table></div><div class=\"TTSummary\">Funzione di codifica del file che applica l\'algoritmo LZW.</div></div>",44:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype44\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">private static int</span> adattaELeggi(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">long</span>&nbsp;</td><td class=\"PName last\">length</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">throws</span> IOException</td></tr></table></div><div class=\"TTSummary\">Questa funzione prende in input un long, che determina il numero di bit da leggere (partendo dal primo bit non letto) dell\'array di byte <b>buffer</b>, e restituisce il valore decimale di tale sequenza di bit.&nbsp; La posizione del primo bit non ancora letto viene salvata nelle variabili contaBit e cont.</div></div>",45:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype45\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">private static void</span> output(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">String&nbsp;</td><td class=\"PName last\">s</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Questa funzione prende in input una stringa <b>s</b>, coverte i suoi caratteri in byte e li carica uno alla volta nel file di destinazione.</div></div>",46:"<div class=\"NDToolTip TFunction LJava\"><div id=\"NDPrototype46\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">public static void</span> decode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">String&nbsp;</td><td class=\"PName last\">source,</td></tr><tr><td class=\"PType first\">String&nbsp;</td><td class=\"PName last\">destName</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">throws</span> IOException</td></tr></table></div><div class=\"TTSummary\">Funzione di decodifica del file che applica l\'algoritmo LZW.</div></div>"});